sub getHash{
	*hash=shift;
	my $filename=shift;
	open FILE,"< $filename" or return -1;
	while(<FILE>){
		$_=~s/##.+//;
		my ($k,$v)=split /=/,$_;
		$k=~s/\s{1,}?//g;
		if($k){
			$v=~s/^\s{1,}?|\r|\n//g;
			$hash{$k}=$v;
		}
	}
	close FILE;
}

sub checkIcon{
	my $icon=shift;
	return ($icon? "./icons/$icon":"./icons/default");
}

sub listDir{
	my $dir=shift;
	opendir DIR,$dir;
	@dirs=sort(readdir DIR);
	closedir DIR;
	return @dirs[2..$#dirs];
}

sub LimitAccess{
	local @options=split(/\?/,$ENV{'HTTP_REFERER'});
	if(lc($options[0]) ne lc("http://$ENV{'SERVER_NAME'}$ENV{'SCRIPT_NAME'}")){
		&WriteLog('error',"$ENV{'REMOTE_ADDR'},$ENV{'HTTP_REFERER'}");
		print "Content-type: text/html\n\nYou Logged from $ENV{'REMOTE_ADDR'}."
		."<br>\nFrom document $ENV{'HTTP_REFERER'}"
		."<br>\nAnd will not response your bad attempt.";
		exit;
	}
}

sub WriteLog{
	local($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst)=localtime(time);
	$mon=$mon+1;
	$mon="0".$mon if($mon<10);
	$day="0".$day if($day<10);
	$hour="0".$hour if($hour<10);
	$min="0".$min if($min<10);
	$sec="0".$sec if($sec<10);

	return if(!(-w "./log"));
	umask 000;
	if(open(FILE,">> ./log/$_[0]_log")){
		print FILE "$_[1],$year/$mon/$day,$weekarray[$wday],$hour:$min:$sec\n";
		close(FILE);
	}
}

sub PrintHeader {
	return "Content-type: text/html\n\n";
}

sub ReadFilePrint{
	local($filename,$print_str)=($_[0],'');
	open (FILE,"< $filename");
	while(<FILE>){ $print_str.=$_;}
	close (FILE);
	return $print_str;
}

sub check_nonchar{
	$tmp_string=$_[0];
	$tmp_string=~s/[\"\']//g;
	$tmp_string=~s/\</&lt\;/g;
	$tmp_string=~s/\>/&gt\;/g;
	return $tmp_string;
}

sub Err_Msg_Back{
	print <<END;
Content-type: text/html

<html>
<script>
<!--
alert("$_[0]");
history.go(-1);
//-->
</script>
END
	exit;
}

sub Download{
	$cgi_name=shift;
	&Err_Msg_Back('Downloading permission denied') if(($cfg{'g_nodl'}==1)&&($_[0] eq 'board'));
	dbmopen %ct_data,$ct_file,0666 or Err_Msg_Back("wowboard error:\\n$msg{'eOpen'}");
	&Err_Msg_Back($msg{'eRead'}) if($ct_data{$in{'i'}.'up'} eq '');
	&Err_Msg_Back($msg{'eOpen'}) unless(open (FILE, "< $gcfg{updir}/$ct_data{$in{'i'}.'up'}"));
	print "Content-type: application/octet-stream\n";
	print "Content-disposition: attachment; filename=$ct_data{$in{'i'}.'re'}\n\n";
	binmode(FILE);
	binmode(STDOUT);
	print <FILE>;
	close(FILE);
	$ct_data{$in{'i'}.'do'}++;
	dbmclose %ct_data;
}

sub table_head{
	my $returnstring="<table cellspacing=0 cellpadding=0 border=0>\n<td"
	.($cfg{'tline'}?' bgcolor="'.$cfg{'tline'}.'"':'')
	."><table width=$table_size cellspacing=1 cellpadding=2 border=0>\n";

	foreach $tbls (@col1){
		$returnstring.="	<td$ttbgimage width=".$cfg{"$tbls$col2[0]"}.$c{"$tbls$col2[1]"}
		.' align=center>'.$c{"$tbls$col2[3]"}."$msg{$tbls}</td>\n" if($cfg{"$tbls$col2[5]"});
	}

	return $returnstring;
}

sub UrlEncode{
	local ($name,$nonchars)=($_[0],$_[0]);
	$nonchars=~s/\w//g;
	local $nonspaces=$nonchars;
	$nonspaces=~s/ //g;

	if($nonchars ne ''){
		if($nonspaces eq ''){
			$name=~s/ /+/g;
		}else{
			$name=~s/(.{1})/'%'.unpack("H2",$1)/ge;
			$name=~s/%20/+/g;
			$name=uc($name);
		}
	}
	return $name;
}

sub MyEncode{
	local $name=$_[0];
	$name=~s/(.{1})/'-'.unpack("H2",$1)/ge;
	return uc($name);
}

sub MyDecode{
	$_[0]=~s/-([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;
	return $_[0];
}

sub Refresh{
	print "Location: http://$ENV{'SERVER_NAME'}$ENV{'SCRIPT_NAME'}$_[0]$_[1]\n\nContent-type: text/html\n\n<META HTTP-EQUIV=\"REFRESH\" CONTENT=\"0\;URL=http://$ENV{'SERVER_NAME'}$ENV{'SCRIPT_NAME'}$_[0]\">";
	exit;
}

sub cal_new{
	local ($day,$weekday)=@_;
	local @mon_table=(31,28,31,30,31,30,31,31,30,31,30,31);
	local($nowday,$nowmon,$nowyear)=(localtime(time))[3..5];
	$emp_day="<font color=$cfg{'ndcol'}>$day $weekday</font>";

	$mon_table[1]=29 unless($nowyear%4);
	$mon_table[1]=28 if(($nowyear%100==0)&&($nowyear%400));
	@tmp=split(/\//,$day);

	if($nowyear==$tmp[0]){
		if($nowmon==($tmp[1]-1)){
			return $emp_day if($nowday-$tmp[2]<$cfg{'ndmargin'});
		}elsif($nowmon==$tmp[1]){
			return $emp_day if(($mon_table[$nowmon-1]-$tmp[2]+$nowday)<$cfg{'ndmargin'});
		}
	}elsif(($nowyear==$tmp[0]+1)&&($nowmon==0)&&($tmp[1]==12)){
		return $emp_day if($mon_table[11]-$tmp[2]+$nowday<$cfg{'ndmargin'});
	}
	return "$day $weekday";			
}

sub print_content{
	local $cgi_name=$_[0];
	$undeletable=$child[0];
	$deletable_msg=($undeletable?$msg{'eRep'}:$msg{'nRep'});
	$id[0]=$msg{'guest'} unless($id[0]);

	@ctstr=('ctback','cbback','ctfore','cbfore');
	for($tmp2=0;$tmp2<2;$tmp2++){
		$c{$ctstr[$tmp2+2]}='<font size=2 color="'.$cfg{$ctstr[$tmp2+2]}.'">';
		$c{$ctstr[$tmp2]}=' bgcolor="'.$cfg{$ctstr[$tmp2]}.'"' if($cfg{$ctstr[$tmp2]});
	}

	$tmp_comment=($cfg{'g_nodl'}==0?"$realname[0], ":'');
	$tmp_comment.=(-s "./$gcfg{updir}/$upname[0]")." bytes";

	$uploaded=($realname[0] ne '')?"<a href=\"$ENV{'SCRIPT_NAME'}?bd=".&UrlEncode($in{'bd'})."&j=dl&i=$idxs[0]&c=".($total_data-$nums[0])."\">$tmp_comment</a>":$msg{'none'};
	$return_str="<table width=$table_size cellspacing=1 cellpadding=2 border=0>\n"
	.'	<td align=right><table><td>'.&showMultiBoard.'</td><td>'.&showPage.'</td></table></td></table>'
	."<table width=$table_size  cellspacing=0 cellpadding=4 border=0>\n	<td$c{'cbback'}$cbbgimage align=left>$c{'cbfore'}";
	$return_str.="$msg{'file'}:$uploaded\<br>$msg{'dcount'}:$dcount[0]</td>" if($cgi_lib'writefiles==0);
	$return_str.="	<td$c{'cbback'}$cbbgimage align=right>$c{'cbfore'}$msg{'num'}:$nums[0]</td>\n</td></table>"
	."<table width=$table_size  cellspacing=0 cellpadding=4 border=0>\n"
	."	<td$c{'ctback'}$ctbgimage align=left width=150>$c{'ctfore'}$msg{'name'}:$id[0]"
	.($email[0]?"\(<a href=\"mailto:$email[0]\"><img src=\"$image_dir/email.gif\" border=0></a>\)":'')
	."</td>\n	<td$c{'ctback'}$ctbgimage align=left width=$cfg{'t_title_size'}>$c{'ctfore'}<b>$title[0]</b></td>\n	<td$c{'ctback'}$ctbgimage align=right>$c{'ctfore'}$msg{'count'}:$count[0]</td></table>\n"
	."<table width=$table_size cellspacing=0 cellpadding=0 border=0>	<td"
	.($cfg{'cline'}?' bgcolor="'.$cfg{'cline'}.'"':'')
	."><table width=$table_size cellspacing=1 cellpadding=10 border=0><td$c{'cbback'}$cbbgimage>$c{'cbfore'}<font face=\"ü\">";

	if(open(CFILE,"< ./data/data$in{bd}/$cont[0]")){
		$content='';
		while(<CFILE>){
			$content.=$_;
		}
		close CFILE;
	}
	$content=~ s/ {2,}/' '.('&nbsp;' x (length($&)-1))/meg;
	$content=~ s/\n/" <br>\n" x (length($&))/meg;
	$content=~ s/^ / &nbsp\;/mg;
	$content=~ s/(^>.*)/<font color=\#006611>$1<\/font>/mg;
	$return_str.="$content</td></table></td></table>";
	return "$return_str\<table width=$table_size cellspacing=0 cellpadding=4 border=0>\n"
	."<td$c{'ctback'}$ctbgimage align=left>$c{'ctfore'}$deletable_msg</td>\n"
	."<td$c{'ctback'}$ctbgimage align=right>$c{'ctfore'}$msg{'time'}: $date[0] $weekarray[$weekday[0]] $thetime[0]</td>\n</table>\n";
}

sub SendMail{
	local $to_addr=lc($_[1]);
	if($to_addr=~/[\@{1}\.{1}]/){
		local $from_addr=$_[0]?"-f $_[0]":'';
		open (MAIL, "|$gcfg{smail_dir} $from_addr -t") || &Err_Msg_Back($msg{'eSMail'});
		print MAIL "To: $to_addr\nSubject: $_[2]\n\n\n$_[3]";
		close (MAIL);
	}
}                

sub findKey{
	*idxs=shift;
	$c=shift;
	$k=shift;

	for($n=$c;$n<=$#idxs;$n++){
		($idxs[$n] eq $k) && return $n;
	}
	for($n=0;$n<$c;$n++){
		($idxs[$n] eq $k) && return $n;
	}
	return -1;
}

sub fetchIndex{
	dbmopen %idx_data,$idx_file,0666;

	@indexes=split /\t/,$idx_data{'index'};

	$total_line=$total_data=$#indexes+1;
	return if($total_data<=0);

	$keyword=$in{'kw'};
	$keyword=~s/\|/\\\|/g;
	$keyword=~s/\s+/\|/g;

	dbmopen %ct_data,$ct_file,0666 or Err_Msg_Back("wowboard error:\\n$msg{'eOpen'}");

	$j=0;
	if(($keyword ne '')&&(($in{'s_title'} ne '')||($in{'s_name'} ne '')||($in{'s_content'} ne ''))){
		$searched=-1;
		for($i=0;$i<$total_data;$i++){
			if($in{'s_content'} ne ''){
				if(open(CFILE,"< ./data/data$in{bd}/".$ct_data{$indexes[$i].'ct'})){
					$content='';
					while(<CFILE>){
						$content.=$_;
					}
					close CFILE;
				}
			}
			if((($in{'s_title'} eq 'yes')&&($ct_data{$indexes[$i].'ti'}=~/$keyword/))||(($in{'s_name'} eq 'yes')&&($ct_data{$indexes[$i].'na'}=~/$keyword/))||(($in{'s_content'} eq 'yes')&&($content=~/$keyword/))){
				$searched++;
				if(($in{'c'}==$searched)&&($in{'j'} eq 'content')){
					$ct_data{$indexes[$i].'co'}++;
					$j=0;
				}
				if($searched>=$in{'c'}){
					($id[$j],$email[$j],$title[$j],$date[$j],$weekday[$j],$thetime[$j],$count[$j],$dcount[$j],$cont[$j],$realname[$j],$upname[$j],$child[$j],$thread[$j])
					=@ct_data{$indexes[$i].'na',$indexes[$i].'em',$indexes[$i].'ti',$indexes[$i].'da'
					,$indexes[$i].'we',$indexes[$i].'tm',$indexes[$i].'co',$indexes[$i].'do'
					,$indexes[$i].'ct',$indexes[$i].'re',$indexes[$i].'up',$indexes[$i].'ch',$indexes[$i].'th'};
					$idxs[$j]=$indexes[$i];
					$nums[$j++]=$total_data-$i;
				}
			}
		}
		$total_line=$searched+1;
	}else{
		for($i=$in{'c'};($i<$in{'c'}+$page)&&($i<$total_data);$i++){
			if(($in{'j'} eq 'content')&&($in{'c'}==$i)){
				$ct_data{$indexes[$i].'co'}++;
				$j=0;
			}
			($id[$j],$email[$j],$title[$j],$date[$j],$weekday[$j],$thetime[$j],$count[$j],$dcount[$j],$cont[$j],$realname[$j],$upname[$j],$child[$j],$thread[$j])
			=@ct_data{$indexes[$i].'na',$indexes[$i].'em',
			$indexes[$i].'ti',$indexes[$i].'da',$indexes[$i].'we',
			$indexes[$i].'tm',$indexes[$i].'co',$indexes[$i].'do',$indexes[$i].'ct',
			$indexes[$i].'re',$indexes[$i].'up',$indexes[$i].'ch',$indexes[$i].'th'};
			$idxs[$j]=$indexes[$i];
			$nums[$j++]=$total_data-$i;
		}
	}
	$bp=$in{'c'}-$page;
	$fp=($in{'c'}+$page<$total_line?$in{'c'}+$page:0);
	$fore=($total_line-1>$in{'c'}?$in{'c'}+1:0);
	$back=$in{'c'}-1;
}

sub Button {
	$cgi_name=shift;
	$page=1 if($in{'j'} ne '');
	$total_page=int(($total_line-1)/$page)+1;

	local $printstr="<table border=0 cellspacing=0 cellpadding=1 border=0>\n<td"
	.($cfg{'bline'}?' bgcolor="'.$cfg{'bline'}.'"':'')
	."><table border=0 width=$table_size cellspacing=0 cellpadding=0 border=0>\n<td"
	.($cfg{bbgimg}?" background='./background/$cfg{bbgimg}'":"")
	.($cfg{'btback'}?' bgcolor="'.$cfg{'btback'}.'"':'')
	."><table border=0 width=".($table_size-2)." cellspacing=0 cellpadding=0 border=0>\n<td"
	.">";
	$printstr.="<table border=0 cellspacing=0 cellpadding=0 border=0>\n";
	if((($in{'j'} ne 'content')&&($cfg{'g_nowr'}==0))||(($in{'j'} eq 'content')&&($cfg{'g_nomd'}==0))||($cgi_name eq 'admin')){
		$printstr.="	<td width=40 align=center><font size=2><a href=\"$ENV{'SCRIPT_NAME'}?kw=$in{'kw'}&bd=".&UrlEncode($in{'bd'});
		$printstr.="&passwd=$enc_pwd" if($cgi_name eq 'admin');
		if($in{'j'} eq "content"){
			$printstr.="&j=reply&c=$in{'c'}&i=$idxs[0]\" $message'$msg{'reply'}'\;return true\"><img src=\"$image_dir/write.gif\" border=0 alt=\"$msg{'reply'}\"><br>$msg{'reply'}</a>";
		}else {
			$printstr.="&j=form\" $message'$msg{'write'}'\;return true\"><img src=\"$image_dir/write.gif\" border=0 alt=\"$msg{'write'}\"><br>$msg{'write'}</a>";
		}
		$printstr.="</td>\n";
	}

	if(($cfg{'g_nomd'}==0)||($cgi_name eq 'admin')){
		$printstr.="	<td width=40 align=center><font size=2 color='$cfg{btfore}'>";
		if($in{'j'} eq "content"){
			$printstr.= "<a href=\"$ENV{'SCRIPT_NAME'}?kw=$in{'kw'}&bd=".&UrlEncode($in{'bd'})."&j=fix&i=$idxs[0]&c=".($total_data-$nums[0]);
			$printstr.="&passwd=$enc_pwd" if($cgi_name eq 'admin');
			$printstr.="\" $message'$msg{'modify'}'\;return true\"><img src=\"$image_dir/fix.gif\" border=0 alt=\"$msg{'modify'}\"><br>$msg{'modify'}</a>";
		}else{	$printstr.= "<img src=\"$image_dir/fix0.gif\"><br>$msg{'modify'}";}
		$printstr.="</td>\n";
	}

	if(($cfg{'g_norm'}==0)||($cgi_name eq 'admin')){
		$printstr.="	<td width=40 align=center><font size=2 color=$cfg{btfore}>";
		if(!$undeletable){
			$printstr.= "<a href=\"$ENV{'SCRIPT_NAME'}?kw=$in{'kw'}&bd=".&UrlEncode($in{'bd'})."&j=delete&i=$idxs[0]&u=$in{'u'}&c=".($total_data-$nums[0]);
			$printstr.="&passwd=$enc_pwd" if($cgi_name eq 'admin');
			$printstr.="\" $message'$msg{'delete'}'\;return true\"><img src=\"$image_dir/delete.gif\" border=0 alt=\"$msg{'delete'}\"><br>$msg{'delete'}</a>";
		}else{
			$printstr.= "<img src=\"$image_dir/delete0.gif\"><br>$msg{'delete'}";
		}
		$printstr.="</td>\n";
	}

	$printstr.="	<td width=40 align=center><font size=2 color=$cfg{btfore}>";
	if(((($in{'s_title'} ne '')||($in{'s_name'} ne '')||($in{'s_content'} ne ''))&&($in{'kw'} ne ''))||($in{'c'}>0)||($in{'j'} eq 'content')){
		$printstr.="<a href=\"$ENV{'SCRIPT_NAME'}?bd=".&UrlEncode($in{'bd'});
		$printstr.="&c=$in{'u'}" if($in{'j'} ne '');
		$printstr.="&passwd=$enc_pwd" if($cgi_name eq 'admin');
		$printstr.="&kw=$in{'kw'}&s_title=$in{'s_title'}&s_name=$in{'s_name'}&s_content=$in{'s_content'}" if(($in{'kw'} ne '')&&($in{'j'} eq 'content'));
		$printstr.= "\" $message'$msg{'list'}'\;return true\"><img src=\"$image_dir/list.gif\" border=0 alt=\"$msg{'list'}\"><br>$msg{'list'}</a>";
	}else {
		$printstr.="<img src=\"$image_dir/list0.gif\"></a><br>$msg{'list'}";
	}
	$printstr.="</td>\n";

	$printstr.="	<td width=40 align=center><font size=2 color=$cfg{btfore}>";
	if((($back>=0)&&($in{'c'}>0)&&($in{'j'} ne''))||(($bp>=0)&&($in{'c'}>0) && ($in{'j'} eq ''))){
		$printstr.="<a href=\"$ENV{'SCRIPT_NAME'}?bd=".&UrlEncode($in{'bd'})."&j=$in{'j'}&u=$in{'u'}&c=".($in{'j'} eq 'content'? $back:$bp);
		$printstr.="&passwd=$enc_pwd" if($cgi_name eq 'admin');
		$printstr.="&kw=".&UrlEncode($in{'kw'})."&s_title=$in{'s_title'}&s_name=$in{'s_name'}&s_content=$in{'s_content'}" if(($keyword ne '')&&(($in{'s_title'} ne '')||($in{'s_name'} ne '')||($in{'s_content'} ne '')));
		$printstr.="\" $message'$msg{'prev'}'\;return true\"><img src=\"$image_dir/back.gif\" border=0 alt=\"$msg{'prev'}\"><br>$msg{'prev'}</a>";
	}else{
		$printstr.="<img src=\"$image_dir/back0.gif\"><br>$msg{'prev'}";
	}
	$printstr.="</td>\n	<td width=40 align=center><font size=2 color=$cfg{btfore}>";

	if(($fore&&($in{'j'} ne''))||($fp && ($in{'j'} eq ''))){
		$printstr.="<a href=\"$ENV{'SCRIPT_NAME'}?bd=".&UrlEncode($in{'bd'})."&j=$in{'j'}&u=$in{'u'}&c=".($in{'j'} eq 'content'? $fore:$fp);
		$printstr.="&passwd=$enc_pwd" if($cgi_name eq 'admin');
		$printstr.="&kw=".&UrlEncode($in{'kw'})."&s_title=$in{'s_title'}&s_name=$in{'s_name'}&s_content=$in{'s_content'}" if(($keyword ne '')&&(($in{'s_title'} ne '')||($in{'s_name'} ne '')||($in{'s_content'} ne '')));
		$printstr.="\" $message'$msg{'next'}'\;return true\"><img src=\"$image_dir/next.gif\" border=0 alt=\"$msg{'next'}\"><br>$msg{'next'}</a>"; 
	}else{
		$printstr.="<img src=\"$image_dir/next0.gif\"><br>$msg{'next'}";
	}

	$printstr.="</td>\n	<td width=40 align=center><font size=2><a href=\"javascript:enterAdmin()\" $message'$msg{'admin'}'\;return true\"><img src=\"$image_dir/admin.gif\" border=0 alt=\"$msg{'admin'}\"><br>$msg{'admin'}</a>" if($cgi_name eq 'board');
	$printstr.="</td>\n	<td width=40 align=center><font size=2><a href=\"$gcfg{home}\" ".($gcfg{f_target}?"target=\"$gcfg{f_target}\"":'')." $message'$msg{'home'}';return true\"><img src=\"$image_dir/home.gif\" border=0 alt=\"$msg{'home'}\"><br>Home</a>" if($cgi_name eq 'board');
	$printstr.="</td>\n</table></td>\n	<td align=right><table border=0 cellspacing=0 cellpadding=0>\n<td colspan=2>";

	$printstr.=&showSearch;
	return "$printstr</td></table></td></table></td></table></td></table>";
}

sub ShortButton {
	$cgi_name=shift;
	$page=1 if($in{'j'} ne '');
	$total_page=int(($total_line-1)/$page)+1;

	local $printstr="<table border=0 cellspacing=0 cellpadding=1 border=0>\n<td"
	.($cfg{'bline'}?' bgcolor="'.$cfg{'bline'}.'"':'')
	."><table border=0 width=".($table_size-2)." cellspacing=0 cellpadding=0 border=0>\n<td"
	.($cfg{bbgimg}?" background='./background/$cfg{bbgimg}'":"")
	.($cfg{'btback'}?' bgcolor="'.$cfg{'btback'}.'"':'')
	."><table border=0 width=".($table_size-2)." cellspacing=0 cellpadding=0 border=0>\n<td>";

	$printstr.="<table border=0 cellspacing=0 cellpadding=0>\n";
	$printstr.="<td nowrap align=center><font size=2 color=$cfg{btfore}>\&nbsp\;";

	if((($in{'j'} ne 'content')&&($cfg{'g_nowr'}==0))||(($in{'j'} eq 'content')&&($cfg{'g_nomd'}==0))||($cgi_name eq 'admin')){
		$printstr.="<a href=\"$ENV{'SCRIPT_NAME'}?kw=$in{'kw'}&bd=".&UrlEncode($in{'bd'})."&c=$in{c}";
		$printstr.="&passwd=$enc_pwd" if($cgi_name eq 'admin');
		if($in{'j'} eq "content"){
			$printstr.="&j=reply&c=$in{c}&i=$idxs[0]&f_name=$in{'f_name'}\" $message'$msg{'reply'}'\;return true\">$msg{'reply'}</a>";
		}else {
			$printstr.="&j=form\" $message'$msg{'write'}'\;return true\">$msg{'write'}</a>";
		}
	}

	if(($cfg{'g_nomd'}==0)||($cgi_name eq 'admin')){
		$printstr.= "/";
		if($in{'j'} eq "content"){
			$printstr.= "<a href=\"$ENV{'SCRIPT_NAME'}?kw=$in{'kw'}&bd=".&UrlEncode($in{'bd'})."&j=fix&i=$idxs[0]&c=".($total_data-$nums[0]);
			$printstr.="&passwd=$enc_pwd" if($cgi_name eq 'admin');
			$printstr.="\" $message'$msg{'modify'}'\;return true\">$msg{'modify'}</a>";
		}else{	$printstr.=$msg{'modify'};}
	}

	if(($cfg{'g_norm'}==0)||($cgi_name eq 'admin')){
		$printstr.= "/";
		if($deletable){
			$printstr.= "<a href=\"$ENV{'SCRIPT_NAME'}?kw=$in{'kw'}&bd=".&UrlEncode($in{'bd'})."&j=delete&i=$idxs[0]&u=$in{u}&c=".($total_data-$nums[0]);
			$printstr.="&passwd=$enc_pwd" if($cgi_name eq 'admin');
			$printstr.="\" $message'$msg{'delete'}'\;return true\">$msg{'delete'}</a>";
		}else{
			$printstr.=$msg{'delete'};
		}
	}
	$printstr.= " &nbsp; ";

	if(((($in{'s_title'} ne '')||($in{'s_name'} ne '')||($in{'s_content'} ne ''))&&($in{'kw'} ne ''))||($in{'c'}>0)||($in{'j'} eq 'content')){
		$printstr.="<a href=\"$ENV{'SCRIPT_NAME'}?bd=".&UrlEncode($in{'bd'});
		$printstr.="&c=$in{'u'}" if($in{'j'} ne '');
		$printstr.="&passwd=$enc_pwd" if($cgi_name eq 'admin');
		$printstr.="&kw=$in{'kw'}&s_title=$in{'s_title'}&s_name=$in{'s_name'}&s_content=$in{'s_content'}" if(($in{'kw'} ne '')&&($in{'j'} eq 'content'));
		$printstr.= "\" $message'$msg{'list'}'\;return true\">$msg{'list'}</a>";
	}else{
		 $printstr.=$msg{'list'};
	}
	$printstr.= "/";
	if((($back>=0)&&($in{'c'}>0)&&($in{'j'} ne''))||(($bp>=0)&&($in{'c'}>0) && ($in{'j'} eq ''))){
		$printstr.="<a href=\"$ENV{'SCRIPT_NAME'}?bd=".&UrlEncode($in{'bd'})."&j=$in{'j'}&c=".($in{'j'} eq 'content'? $back:$bp);
		$printstr.="&passwd=$enc_pwd" if($cgi_name eq 'admin');
		$printstr.="&kw=".&UrlEncode($in{'kw'})."&s_title=$in{'s_title'}&s_name=$in{'s_name'}&s_content=$in{'s_content'}" if(($keyword ne '')&&(($in{'s_title'} ne '')||($in{'s_name'} ne '')||($in{'s_content'} ne '')));
		$printstr.="\" $message'$msg{'prev'}'\;return true\">$msg{'prev'}</a>";
	}else{
		$printstr.=$msg{'prev'};
	}
	$printstr.= "/";
	if(($fore&&($in{'j'} ne''))||($fp && ($in{'j'} eq ''))){
		$printstr.="<a href=\"$ENV{'SCRIPT_NAME'}?bd=".&UrlEncode($in{'bd'})."&j=$in{'j'}&c=".($in{'j'} eq 'content'? $fore:$fp);
		$printstr.="&passwd=$enc_pwd" if($cgi_name eq 'admin');
		$printstr.="&kw=".&UrlEncode($in{'kw'})."&s_title=$in{'s_title'}&s_name=$in{'s_name'}&s_content=$in{'s_content'}" if(($keyword ne '')&&(($in{'s_title'} ne '')||($in{'s_name'} ne '')||($in{'s_content'} ne '')));
		$printstr.="\" $message'$msg{'next'}'\;return true\">$msg{'next'}</a>"; 
	}else{
		$printstr.=$msg{'next'};
	}
	$table_size-=($cgi_name eq 'board'?320:240);
	$printstr.=" &nbsp; <a href=\"javascript:enterAdmin()\" $message'$msg{'admin'}'\;return true\">$msg{'admin'}</a>" if($cgi_name eq 'board');
	$printstr.="/<a href=\"$gcfg{home}\" ".($gcfg{f_target}?"target=\"$gcfg{f_target}\"":'')."$msg{'home'}';return true\">Home</a>\n" if($cgi_name eq 'board');
	$printstr.="</td>\n</table></td>\n<td align=right><table border=0 cellspacing=0 cellpadding=0>\n<td colspan=2>";

	$printstr.=&showSearch;
	return "$printstr</td></table></td>\n</table></td>\n</table></td></table>";
}

sub showSearch{
	$returnstr="<table border=0 cellspacing=0 cellpadding=0><form action=\"$ENV{'SCRIPT_NAME'}\" method='GET'><td align=center><font <font size=2 color='$cfg{btfore}' face=\"\">";
	$returnstr.="<input type='hidden' name='bd' value=\"$in{'bd'}\">";
	$returnstr.="<input type='hidden' name='passwd' value=\"$enc_pwd\">\n" if($cgi_name eq 'admin');
	return "$returnstr<input ".($in{'s_title'}eq 'yes'?'checked ':'')."type='checkbox' name='s_title' value='yes'>$msg{'title'} &nbsp\;&nbsp\;&nbsp\;<input ".($in{'s_name'}eq 'yes'?'checked ':'')."type=checkbox name=s_name value=yes>$msg{'name'} &nbsp\;&nbsp\;&nbsp\;<input ".($in{'s_content'}eq 'yes'?'checked ':'')."type=checkbox name=s_content value=yes>$msg{'content'}&nbsp\;<br><font size=3><input size=11 maxlength=20 name=kw value=\"$in{'kw'}\"></font><input type=submit value=\"$msg{'search'}\"></td></form></table>";
}

sub showMultiBoard{
	$returnstr="<table border=0 cellspacing=0 cellpadding=0><form action=\"$ENV{'SCRIPT_NAME'}\" method=\"GET\"><td><font size=2>";
	$returnstr.="<input type=hidden name=passwd value=\"$enc_pwd\">\n" if($cgi_name eq 'admin');
	$returnstr.="<select name=\"bd\" onChange='this.form.submit()'>\n";

	dbmclose %mlt;
	dbmopen %mlt,'./data/multidb',0666;

	$returnstr.='<option value="">Free Board' if(keys(%mlt)<=0);
	foreach $_ (sort(keys(%mlt))){
		$bd_dir=$_;
		$bd_dir=~s/^data//;
		$returnstr.="<option ".($bd_dir eq $in{'bd'}?'selected ':'')."value=\"$bd_dir\"\>$mlt{$_}\n";
	}
	return "$returnstr</select></td></form></table>";
}

sub showPage{
	$page=1 if($in{'j'} ne '');
	$total_page=int(($total_line-1)/$page)+1;
	$returnstr="<table border=0 cellspacing=0 cellpadding=0><form action=\"$ENV{'SCRIPT_NAME'}\" method=\"GET\"><td><font size=2><input type=hidden name=\"bd\" value=\"$in{'bd'}\"><input type=hidden name=\"j\" value=\"$in{'j'}\">";
	$returnstr.="<input type=hidden name=passwd value=\"$enc_pwd\">\n" if($cgi_name eq 'admin');
	$returnstr.="<input type=hidden name=kw value=\"$in{'kw'}\"><input type=hidden name=s_title value=\"$in{'s_title'}\"><input type=hidden name=s_name value=\"$in{'s_name'}\"><input type=hidden name=s_content value=\"$in{'s_content'}\">" if(($keyword ne '')&&(($in{'s_title'} ne '')||($in{'s_name'} ne '')||($in{'s_content'} ne '')));

	if($in{'j'} eq ''){
		$returnstr.="\<select name=\"c\" onChange='this.form.submit()'>\n";
		for($i=1;$i<=$total_page;$i++){
			$returnstr.="\<option ";
			if($i==int($in{'c'}/$page)+1){ $returnstr.="selected ";}
			$returnstr.="value=\"".(($i-1)*$page)."\"\>$i/$total_page$msg{'page'}\n";
		}
	}else{
		$returnstr.="\<select name=\"c\" onChange='this.form.submit()'>\n";
		for($i=1;$i<=$total_page;$i++){
			$returnstr.="\<option ";
			$returnstr.="selected " if($in{'c'}==$i-1);
			$returnstr.="value=\"".($i-1)."\"\>$i/$total_page$msg{'page'}\n";
		}
	}
	return "$returnstr\</select></td></form></table>";
}

1;